#!/usr/bin/python
# This installs the CAEDM "Print Driver" to the users computer.
# First we test if the print driver has been installed before, and if so, we will re-install.
import os, shutil, pwd, grp, time, distutils, sys, platform
from distutils import dir_util

if( platform.system() == 'Darwin' ):
	mac = 1
	linux = 0
elif( platform.system() == 'Linux' ):
	linux = 1
	mac = 0
else:
	print "Unsupported OS."
	sys.exit(1)

print "Welcome to the CAEDM Print Driver Interface installation. Please be sure you are running this script as root, otherwise it won't work... \n\n\n"

time.sleep(3)
print "Again, MAKE SURE YOU ARE ROOT!"
time.sleep(1)

OPT_FILE = '/opt/.GSIR5hzk1VbSsXH3GL8Y'

if(os.path.exists('/usr/bin/caedm-app')):
	print "A previous installation has been found. Re-installing... \n"

#system specific info
if(os.path.exists('/usr/bin/yum')):
	print "Installing some necessary RPMs..."
	try:
#		os.system("yum localinstall wxBase-2.8.12-1.el6.x86_64.rpm")
		os.system("yum -y localinstall libwxgtk-2.8.12-3.el6.x86_64.rpm")
		os.system("yum -y localinstall wxPython-2.8.12.0-1.el6.x86_64.rpm")
		os.system("yum -y install python-setuptools")
		os.system("yum -y groupinstall 'Development Tools'")
		os.system("yum -y install python-devel")
	except:
		print "Failed in installing external packages."
		sys.exit(1)
elif(os.path.exists('/usr/bin/apt-get')):
	print "Installing some necessary DEBs..."
	try:
		os.system("export DEBIAN_FRONTEND=noninteractive")
		os.system("apt-get -q -y install python-dev python-setuptools python-wxgtk2.8")
	except:
		print "Failed in installing external packages."
		sys.exit(1)

#now we install some necessary python modules using setuptools
if ( linux ):
	try:
		os.system("easy_install requests Crypto pycrypto  python-magic")
	except:
		print "Failed at the module install."
		sys.exit(1)
	


#now copying the necessary files
if ( linux ):
	try:
		distutils.dir_util.copy_tree("./caedm", "/usr/share/caedm")
		shutil.copy("./caedm-app", "/usr/bin/caedm-app")
		shutil.copy("./caedm-backend", "/usr/lib/cups/backend/caedm")	
		shutil.copy("./caedm-init.sh", "/etc/profile.d/caedm-init.sh")
		if(os.path.exists("/uxapps/.lock.pmg")):
			print "We are on a CAEDM lab machine. Skipping the installation of the /opt/.GSIR5hzk1VbSsXH3GL8Y file."
		else:
			shutil.copy("./.optfile", OPT_FILE )
			#now change permissions of file installed
			lp_uid = pwd.getpwnam("lp").pw_uid
			lp_gid = grp.getgrnam("lp").gr_gid
			os.chown(OPT_FILE, lp_uid, lp_gid)
			os.chmod(OPT_FILE, 0660)
		os.chmod("/usr/bin/caedm-app", 0755)
		os.chmod("/usr/lib/cups/backend/caedm", 0755)

	except:	
		print "Unable to copy installation files. Are you sure you are root?"
		sys.exit(1)
else: # if ( mac )
	#try:
	distutils.dir_util.copy_tree("./caedm", "/Library/caedm")
	shutil.copy("./caedm-app-mac", "/usr/bin/caedm-app")
	shutil.copy("./caedm-backend", "/usr/libexec/cups/backend/caedm")
	shutil.copy("./.optfile", OPT_FILE )
	#now change permissions of file installed
	lp_uid = os.getuid()
	lp_gid = grp.getgrnam("_lp").gr_gid
	os.chown(OPT_FILE, lp_uid, lp_gid)
	os.chmod(OPT_FILE, 0640)
	os.chmod("/usr/bin/caedm-app", 0755)
	os.chmod("/usr/libexec/cups/backend/caedm", 0755)		
	#copying the necessary 'poppler' files to make PDF conversion possible
	shutil.copy("./pdftops", "/usr/bin/pdftops")
	if ( os.path.exists('/usr/local/Cellar/') == 0  ):
		os.mkdir('/usr/local/Cellar')
	if ( os.path.exists('/usr/local/Cellar/poppler/') == 0 ):
		distutils.dir_util.copy_tree("./poppler", "/usr/local/Cellar/poppler")
#	except:
#		print "Unable to copy installation files. Are you sure you are root?"




#now add the printer
os.system('lpadmin -p "CAEDM" -E -v caedm:/tmp  -D "Print to any CAEDM printer."')
if ( mac ):
	distutils.dir_util.copy_tree("./CAEDM Print Driver Authentication.app", "/Applications/CAEDM Print Driver Authentication.app")
	os.system("open /Applications/CAEDM\ Print\ Driver\ Authentication.app")

print "\n\n\nAll went well! Installation complete. Please log-off and log back in for all changes to take effect. Print driver WILL NOT function until you do this. Exiting..."
time.sleep(3)
sys.exit(0)
